from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addSubcomponent("boat", "Tug", inherit=True, prefix=None)
c.inheritAllInterfaces("boat")

c.addConstConstraint(("boat", "length"), 156)
c.addConstConstraint(("boat", "width"), 90)
c.addConstConstraint(("boat", "depth"), 70)

c.addSubcomponent("servostackbattery", "ServoStackBatteryMount")
c.inheritAllInterfaces("servostackbattery")

c.addConnection(("boat", "portedge"), ("servostackbattery", "lTopSplit")) #both face the same direction
c.addConnection(("boat", "staredge"), ("servostackbattery", "rTopSplit"))

c.toLibrary("HouseboatWithServoMountAndStack")
