from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addSubcomponent("servosandstack", "ServoStackMount", inherit=("lServoMount.depth", "lServoMount.width", "stack.length"), prefix=None)
c.inheritAllInterfaces("servosandstack")

c.addSubcomponent("batterymount", "BatteryMount", inherit="batterylength")
c.inheritAllInterfaces("batterymount")

c.addSubcomponent("lfullsplit", "SplitEdge", inherit=True)
c.inheritAllInterfaces("lfullsplit")
c.addConstraint(("lfullsplit", "toplength"), ("lServoMount.depth", "lServoMount.width", "stack.length", "batterymount.batterylength"), "(x[0]*2+x[1]*2+10*2+x[2]+x[3],)")
c.addConstraint(("lfullsplit", "botlength"), ("lServoMount.depth", "lServoMount.width", "stack.length", "batterymount.batterylength"), "(x[0]*2+x[1]*2+10*2+x[2], x[3])")
#
c.addConnection(("lfullsplit", "botedge1"), ("batterymount", "rightArmInterface"), tabWidth=10)
c.addConnection(("lfullsplit", "botedge0"), ("servosandstack", "lservostacksplit"))

c.addSubcomponent("rfullsplit", "SplitEdge", inherit=True)
c.inheritAllInterfaces("rfullsplit")
c.addConstraint(("rfullsplit", "toplength"), ("lServoMount.depth", "lServoMount.width", "stack.length", "batterymount.batterylength"), "(x[0]*2+x[1]*2+10*2+x[2]+x[3],)")
c.addConstraint(("rfullsplit", "botlength"), ("lServoMount.depth", "lServoMount.width", "stack.length", "batterymount.batterylength"), "(x[3], x[0]*2+x[1]*2+10*2+x[2])")
#
c.addConnection(("rfullsplit", "botedge0"), ("batterymount", "leftArmInterface"))
c.addConnection(("rfullsplit", "botedge1"), ("servosandstack", "rservostacksplit"))

c.inheritInterface("lTopSplit", ("lfullsplit", "topedge0"))
c.inheritInterface("rTopSplit", ("rfullsplit", "topedge0"))

c.toLibrary("ServoStackBatteryMount")
